﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.Editors;
using Infragistics.Windows.Controls;
using Infragistics.Windows;
using System.Collections.ObjectModel;

namespace WpfApplication2
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        int position = 0;

        public MainWindow()
        {
            InitializeComponent();
            List<Variables> data1 = new List<Variables>();
            data1.Add(new Variables() { Variable = "Variable1" });
            data1.Add(new Variables() { Variable = "Variable2" });
            data1.Add(new Variables() { Variable = "Variable3" });
            xamDataGrid1.DataContext = new ObservableCollection<Variables>(data1);

            List<Expressions> data2 = new List<Expressions>();
            data2.Add(new Expressions() { Expression = "Expression1" });
            data2.Add(new Expressions() { Expression = "Expression2" });
            data2.Add(new Expressions() { Expression = "Expression3" });
            xamDataGrid2.DataContext = new ObservableCollection<Expressions>(data2);
        }

        private void xamDataGrid1_MouseDoubleClick(object sender, MouseButtonEventArgs e)
        {
                // get the caret, insert the text and move the caret to the end of the new insertion.
                XamTextEditor activeTextEditor = Utilities.GetDescendantFromType(CellValuePresenter.FromCell(xamDataGrid2.ActiveRecord.DataPresenter.ActiveCell), 
                    typeof(XamTextEditor), true) as XamTextEditor;
                activeTextEditor.StartEditMode();
                string selectedText = (xamDataGrid1.ActiveDataItem as Variables).Variable;
                activeTextEditor.SelectionStart = position;
                activeTextEditor.Text = activeTextEditor.Text.Insert(position, selectedText);
                Console.WriteLine(activeTextEditor.Text);
                activeTextEditor.SelectionStart = position + selectedText.Length;
        }

        private void xamDataGrid2_EditModeEnding(object sender, Infragistics.Windows.DataPresenter.Events.EditModeEndingEventArgs e)
        {
            position = (e.Editor as XamTextEditor).SelectionStart;
        }
    }

    public class Variables : INotifyPropertyChanged
    {
        private String variable;

        public String Variable
        {
            get { return variable; }
            set { variable = value; NotifyPropertyChanged("Variable"); }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }
    }

    public class Expressions : INotifyPropertyChanged
    {

        private String expression;

        public String Expression
        {
            get { return expression; }
            set { expression = value; NotifyPropertyChanged("Expression"); }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }
    }
}
